%gtPreprocessing - "do all" script to handle all preprocessing
%parameters file, created by gtSetup, should have all required directorry
%info.  Run this script in the top level analysis directory (containig the
%parameters file)
%live! launch a series of condor jobs which will sit and wait
%gtCopyCorrectUndistortWrapper launches a number of instances of
%condor_... according to how many files are present in the directory
%when the function is started.

%version _taper
%doesn't deal with abs/ext images, and calls create_full_taper


function gtPreprocessing_live_taper

  
if exist('parameters.mat', 'file')
  load('parameters.mat');;
else
disp('first run gtSetup to create parameters file for the experiment, or go to the directory containing this file!')
return
end

freshcompile=false;  % recompile binaries - not often needed.  But more often than it should be...
use_cronii=false;  % submit jobs to cronus.  Shhhh...
% some basic checks
% dark file exists?

% xml file exists?

% source and target directory exist?
if freshcompile
  disp('recompiling all functions')
  id19_mcc('sequence_median_refs')
  gt_mcc('create_abs_live');
  gt_mcc('gtAbsMedian_live');
  gt_mcc('gtMovingMedian_live');
  gt_mcc('create_full_live');
%  gt_mcc('copyKodak');  %replaced by gtCopyCorrectUndistortWrapper
end



%copy data from acquistion directory to analysis location
sourcedir=parameters.acq.collection_dir;
rawdir=sprintf('%s/0_rawdata/%s', parameters.acq.dir, parameters.acq.name);
sensortype=parameters.acq.sensortype;
distmapfile=parameters.acq.distortion;
if strcmp(parameters.acq.type, '180degree')
  nimages=parameters.acq.nproj;
elseif strcmp(parameters.acq.type, '360degree')
  nimages=parameters.acq.nproj*2;
else
  gtError('unrecognised data type')
end
  
%keyboard
%gtCopyCorrectUndistortWrapper handles condoring of copying
gtCopyCorrectUndistortWrapper(parameters, sourcedir, rawdir)

%sequence median refs RHST in raw data
condor_make('gt_sequence_median_refs', 0, 0, 1, [rawdir ' ' nimages ' overwrite'], true,use_cronii) 
disp('gt_sequence_median_refs launched') %note - gt_sequ... can work from the parameters.mat rather than from the xml

%gtMovingMedian
condor_make('gtMovingMedian_live', 0, nimages, 1, parameters.acq.dir, true,use_cronii); 
%make large meds in full directory, quick enough for a single machine
disp('gtMovingMedian_live launched')

%create_full
condor_make('create_full_taper', 0, nimages, 30, parameters.acq.dir, true,use_cronii); 
%make full images and ext images
disp('create_full_taper launched')


  
  
