function seg = gtSegDefaultParameters()

seg.bbox                = [];
seg.method              = 'doublethr';
seg.thr_single          = 3;         % threshold for ''single threshold'' segmentation
seg.thr_seed            = 50;        % threshold for finding seeds (for double threshold)
seg.thr_grow_rat        = 0.1;       % relative threshold for growing seeds (for double threshold)
seg.thr_grow_low        = 7;         % lower limit of threshold for growing seeds (for double threshold)
seg.thr_grow_high       = 20;        % upper limit of threshold for growing seeds (for double threshold)
seg.seedminarea         = 10;
seg.minsize             = 50;
seg.minint              = 100;
seg.icut                = 0.1;       % difspots may extend over tens of images - we will sum up extspots only in the intensity percentile range [seg.icut : 1-seg.icut]
seg.omintlimmin         = 0.0005;    % indicates first and last image in the stack with this minimum relative intensity
seg.omintlimtail        = 0.0005;    % size of tails cut off the summed intensity curve through the image stack
seg.minblobsize         = [10 10 0];
seg.maxblobsize         = [300 300 40];
seg.extendblobinc       = [30 30 2];
seg.background_subtract = true;
seg.overlaps_removed    = false;
seg.difspotmask         = 'blob3Dsoft'; % mask used to create difspot.edf from blob
                                        % ('none'/'blob2D'/'blob2Dsoft'/'blob3D'/'blob3Dsoft')
end
