function gtDoAll2;
% remove seg2vie.sh
% truncate grainid
% set GrainID in extspot to null
% remove -r 4_grain/*

%gtDoAll2 - simplify to use streamlined HandleSpot2...



%load data
parameters=[];

if isempty(parameters)
  load('parameters.mat');
end

cd(parameters.acq.dir);
cand=gtSelectCandidates(180,185);

grainID = 1;

if exist(sprintf('4_grains/grain%d_',grainID),'dir')
  disp(sprintf('4_grains/grain%d_/ already exists! Either delete it, or change grainID in DoAll2! Aborting...',grainID))
  return
end



fprintf('Candidate list length: %d\n',length(cand));

for i=1:length(cand)
  
  close all
  
  if mym(sprintf('select !isnull(GrainID) from %sextspot where (extspotID=%d)',parameters.acq.name,cand(i)));
    % GrainID has already been allocated to this candidate
    continue % bomb out of loop
  end
  
% % request a GrainID to use - use simpler system for test
 % mym(sprintf('insert into %sgrainid set grainID=default',parameters.acq.name));
  %grainID=mym(sprintf('select last_insert_id()'));
 
  
  fprintf('now looking at candidate %d of %d (family belonging to extspot(%d)) using grainID %d\n',i,length(cand),cand(i),grainID);
  
  %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  accept = gtHandleSpot2_180(cand(i),grainID);
  %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  if accept
  %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  gtWriteStack(grainID);
  %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  
  %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  gtDoART(grainID);
  %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  
  %increment grainID
  grainID=grainID+1;
  
  end
  
  cd(parameters.acq.dir);
  close all

end

disp('Done!')
