function gt_batchAutoFind(first,last,wdir)
if isdeployed
  global GT_DB
  global GT_MATLAB_HOME
  load('workspaceGlobal.mat');
  first=str2double(first);
  last=str2double(last);
end
cd(wdir)
parameters=[];
if isempty(parameters)
  load('parameters.mat');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   SIZE ORDERING
%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Opening database')
mym('open','mysql.esrf.fr','gtuser','gtuser');
mym('use graintracking');
[remaining]=mym(sprintf(...
  'select difspotID from %sdifspot where difspotID>=%d and difspotID<=%d order by Area desc',...
  parameters.acq.name,first,last));
fprintf('First %d Last %d Number %d\n',first,last,length(remaining))


for i=1:length(remaining)
  try 
    struct_id=remaining(i);
    fprintf('~~~~~~ Doing difspot %d, with %d remaining (struct_id = %d) ~~~~~~~~~\n', i,length(remaining),struct_id)
    AutoFind(struct_id,parameters,1);% 1 because already connected to mysql
    fprintf('~~~~~~~~ DONE OK ~~~~~~~~\n\n\n');
  catch
    fprintf('~~~~~~~~~ SPOT UNFINISHED ~~~~~~~~~~\n')
    tmp=lasterror;
    fprintf('Error: %s \n%s at line %d\n',tmp.message,tmp.stack(1).file,tmp.stack(1).line);
    fprintf('\n\n\n');
  end
end

mym('close')


