%for Andreas2_ multilayer dataset.  Try indexing based on scattering
%vectors only.  
%Simple approach for the small dataset
function [difAID, difBID, r_vector, grain_pos] = gtPairs2Grains(x)

dev_test=1;%what angular tolerence? (degrees)
real_test=4;%what real space tolerance? (grainsize/real_test)
plot_flag=1; %plot figures? - slow because of looking up spot images

gtDBConnect
parameters=[];
load('parameters.mat');

%first need to pick a large, paired 111 or 002 (or anything?)
candidates = sfSelectPairedCandidates;
%candidates is the pairID

candidate=candidates(x);



%get the data that will be used
[pairIDs,plX,plY,plZ,thetatype]=mym('select pairID, plX, plY, plZ, thetatype from ss_crackedAB_spotpairs where thetatype=1 or thetatype=2');
[lorX, lorY, lorZ, ldirX, ldirY, ldirZ]=mym('select lorX, lorY, lorZ, ldirX, ldirY, ldirZ from ss_crackedAB_spotpairs where thetatype=1 or thetatype=2');
[difAIDs, difBIDs]=mym('select difAID, difBID from ss_crackedAB_spotpairs where thetatype=1 or thetatype=2');
linedata=[lorX, lorY, lorZ, ldirX, ldirY, ldirZ];
plane_normals = zeros(length(plX), 3);
plane_normals(:,1) = plX;
plane_normals(:,2) = plY;
plane_normals(:,3) = plZ;
hkls=zeros(length(thetatype), 3);
hkls(find(thetatype==1),:)=repmat([1 1 1],length(find(thetatype==1)),1);
hkls(find(thetatype==2),:)=repmat([0 0 2],length(find(thetatype==2)),1);

%deal with the first two diffraction rings only - low multiplicities means
%less spots to consider - mixed blessing.
allowed_angles11=sfGetAllowedAngles([1 1 1], [1 1 1]);
allowed_angles12=sfGetAllowedAngles([1 1 1], [0 0 2]);
allowed_angles22=sfGetAllowedAngles([0 0 2], [0 0 2]);
allowed_angles11=repmat(allowed_angles11,length(plane_normals),1);
allowed_angles12=repmat(allowed_angles12,length(plane_normals),1);
allowed_angles22=repmat(allowed_angles22,length(plane_normals),1);

%pick out the candidate
testpair=find(pairIDs==candidate);

subject_normal=plane_normals(testpair,:);
subject_normal=repmat(subject_normal, size(plane_normals,1), 1);
%interplanar angles in degrees
angles=(180/pi)*acos(dot(subject_normal, plane_normals, 2));

shortlist=[];

if thetatype(testpair)==1
  %test against all 111-111 allowed angles
  dev_angles = abs(repmat(angles,1,size(allowed_angles11,2)) - allowed_angles11);
  dev_angles = min(dev_angles,[],2);
  shortlist=find(dev_angles<dev_test & thetatype==1);
  %plus do the 111-002 combinations
  dev_angles = abs(repmat(angles,1,size(allowed_angles12,2)) - allowed_angles12);
  dev_angles = min(dev_angles,[],2);
  shortlist = [shortlist; find(dev_angles<dev_test & thetatype==2)];
elseif thetatype(testpair)==2
  %test against all 002-002 allowed angles
  dev_angles = abs(repmat(angles,1,size(allowed_angles22,2)) - allowed_angles22);
  dev_angles = min(dev_angles,[],2);
  shortlist=find(dev_angles<dev_test & thetatype==2);
  %plus do the 111-002 combinations
  dev_angles = abs(repmat(angles,1,size(allowed_angles12,2)) - allowed_angles12);
  dev_angles = min(dev_angles,[],2);
  shortlist = [shortlist; find(dev_angles<dev_test & thetatype==1)];
end


%This is a shortlist of possible plane normals according to scattering
%vector direction.  
%...now, do real space

%get difspot data
[difAID, difBID]=mym(sprintf('select difAID, difBID from ss_crackedAB_spotpairs where pairID=%d',candidate));
[spotsizex(1), spotsizey(1)]=mym(sprintf('select boundingboxXsize, boundingboxYsize from ss_crackedA_difspot where difspotid=%d',difAID));
[spotsizex(2), spotsizey(2)]=mym(sprintf('select boundingboxXsize, boundingboxYsize from ss_crackedB_difspot where difspotid=%d',difBID));
spotsizex=mean(spotsizex);
spotsizey=mean(spotsizey);
spotsize=mean([spotsizex spotsizey]);

distance=zeros(size(shortlist));
points=zeros(length(shortlist),3);

if plot_flag
%testpair line:
point1=linedata(testpair,1:3);
point1=point1-3000*linedata(testpair,4:6);
point2=point1-1000*linedata(testpair,4:6);
pdata=[point1; point2];
figure
hold on
plot3(pdata(:,1), pdata(:,2), pdata(:,3),'r')
end

%pick out intersections from which a grain position can be refined
grainpoints=[];
for a=1:length(shortlist)
  point=pofintersectexp(linedata([testpair shortlist(a)], :))'; %best point between the two lines
  distance(a)=pointtolinedist(point, linedata(testpair, :));
  points(a,:)=point;
  
  %if lines are ~ parallel, this gets ugly
  if distance(a)>25
  plot3(point(1), point(2), point(3), 'go')
  elseif distance(a) >5
    plot3(point(1), point(2), point(3), 'ro')
  else
    if angles(shortlist(a))>5 %only plot if the angle is greater than 5 degrees
      %similarly, can only get grain position from lines more than a few
      %degrees apart.
      if plot_flag
        plot3(point(1), point(2), point(3), 'bo')
      end
      grainpoints=[grainpoints; point];%use to refine position
    end
  end
end


%then, refine grain position
%need outlier rejecting least squares approach from grainpoints.
%to work in a single variable, use t, where t is a coordinate along the path
%of the original spot

%hard code some sensible limits
tmin=3000
tmax=4000

t_grain = fminbnd(@(t) sfFindGrain(grainpoints, t), tmin, tmax);

x_grain=linedata(testpair,1)-t_grain*linedata(testpair,4);
y_grain=linedata(testpair,2)-t_grain*linedata(testpair,5);
z_grain=linedata(testpair,3)-t_grain*linedata(testpair,6);

plot3(x_grain, y_grain, z_grain, 'xr', 'markersize', 20)

%Finally (?) reject those lines which intersect too far from the grain
%position
dist = points-repmat([x_grain y_grain z_grain], size(points, 1), 1);
dist = sqrt(sum((dist.*dist),2)); % distance of each point from grain
shortlist2 = shortlist;
shortlist2(find(dist>spotsize/real_test))=[];
points2=points;
points2(find(dist>spotsize/real_test), :)=[]; %points is now same length as shortlist2


if plot_flag
  %look at these spots
  figure
  for a=1:length(shortlist2)
    im=gtGetSummedDifSpot_pair(difAIDs(shortlist2(a)), 1);
    subplot(2,length(shortlist2), a); imshow(im, [])
    im=gtGetSummedDifSpot_pair(difBIDs(shortlist2(a)), 2);
    subplot(2,length(shortlist2), a+length(shortlist2)); imshow(im, [])
  end
end

%run consistancy test of the final group of spots
[r_vector, goods]=plot_rodrigues_consistancy(plane_normals(shortlist2,:), hkls(shortlist2,:),plot_flag);
points3=points2(goods,:)
shortlist3=shortlist2(goods)

if plot_flag
  figure
  for a=1:length(shortlist3)
    im=gtGetSummedDifSpot_pair(difAIDs(shortlist3(a)), 1);
    subplot(2,length(shortlist3), a); imshow(im, [])
    im=gtGetSummedDifSpot_pair(difBIDs(shortlist3(a)), 2);
    subplot(2,length(shortlist3), a+length(shortlist3)); imshow(im, [])
  end
end


%for output
difAID=difAIDs(shortlist3)
difBID=difBIDs(shortlist3)

%should refine grain position again, having done the consistancy check
t_grain = fminbnd(@(t) sfFindGrain(points3, t), tmin, tmax);

x_grain=linedata(testpair,1)-t_grain*linedata(testpair,4);
y_grain=linedata(testpair,2)-t_grain*linedata(testpair,5);
z_grain=linedata(testpair,3)-t_grain*linedata(testpair,6);

grain_pos=[x_grain y_grain z_grain];

%then, call forward simulate to get anything missed, any unpaired spots,
%and any higher order {hkl} pairs.
%assemble data
struct_ids=[difAID; difBID];
pair_vector=[ones(size(difAID)); 2*ones(size(difBID))];
[struct_ids_new, pair_vector_new] = gtForwardSimulate_pair2grain(grain_pos, r_vector, struct_ids, pair_vector, parameters)

%now, assemble all info for these new spots.  
struct_ids=[struct_ids; struct_ids_new'];
pair_vector=[pair_vector; pair_vector_new'];
grainTheta=[]; grainEta=[]; grainOmega=[]; GrainPlane_normals=[];

for i=1:length(struct_ids)
  %get info from pair table if spots are paired
  if pair_vector(i)==1
    mysqlcmd=sprintf('select theta, eta, omega, plX, plY, plZ from ss_crackedAB_spotpairs where difAID=%d',struct_ids(i));
  else
    mysqlcmd=sprintf('select theta, eta, omega, plX, plY, plZ from ss_crackedAB_spotpairs where difBID=%d',struct_ids(i));
  end
  [th,et,om,plX,plY,plZ]=mym(mysqlcmd);

  if ~isnan(th)
    if pair_vector(i)==1
      grainTheta(i)=th; grainEta(i)=et; grainOmega(i)=om;
      grainPlane_normals(i,1:3)=[plX plY plZ];
    else
      grainTheta(i)=th; grainEta(i)=180-et; grainOmega(i)=om+180;
      if grainEta(i)<0
        grainEta(i)=grainEta(i)+360;
      end
      grainPlane_normals(i,1:3)=[-plX -plY -plZ];
    end

  else%if no info found in pair table, calculate it from grain position
    [th,et,om,plX,plY,plZ]=sfCalcAngles(struct_ids(i), pair_vector(i), grain_pos);
    grainTheta(i)=th; grainEta(i)=et; grainOmega(i)=om;
    grainPlane_normals(i,1:3)=[plX plY plZ];
  end

end

%consistancy check again to be sure, shouldn't discard anything...
%at this point, really need to have hkls assigned. For pairs, this in table,
%but for others it needs to be done from scratch
%note, gtIndexReflections can also return plane normals
[tmp, hkls] = gtIndexReflections(grainTheta, grainEta, grainOmega, parameters)


keyboard
%do we need a pseudo-twin ckeck somewhere?


%remove everything claimed by a grain from the lists, and go again with the
%next candidate.





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function output = sfFindGrain(good_points, t_grain)
%function for fminbnd to find grain position along original projection
x_grain=linedata(testpair,1)-t_grain*linedata(testpair,4);
y_grain=linedata(testpair,2)-t_grain*linedata(testpair,5);
z_grain=linedata(testpair,3)-t_grain*linedata(testpair,6);

dist = good_points-repmat([x_grain y_grain z_grain], size(good_points, 1), 1);
dist = sqrt(sum((dist.*dist),2)); % distance of each point from grain
%minimise sum of squares for the closest half of the points, to reduce
%effect of outliers
dist = sort(dist,1,'descend');
tmp = ceil(size(dist,1)/2);
dist(1:tmp)=[];
output = dist'*dist;%sum of squares
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  function cand = sfSelectPairedCandidates
    %returns all paired thetatype=1 pairids
  difA_name='ss_crackedA_';
  pairtablename='ss_crackedAB_';
  cand=mym(sprintf([...
  'select %sspotpairs.pairID from %sspotpairs inner join %sdifspot on difAID=difspotID '...
  'where thetatype=1 or thetatype=2 order by boundingboxYsize desc'],...
  pairtablename,pairtablename,difA_name));
  end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function allowed_angles = sfGetAllowedAngles(hkl_1,hkl_2)
%get the allowed interplanar angles
hkl_m1 = gtGetReflections(hkl_1);
hkl_m2 = gtGetReflections(hkl_2);
allowed_angles = [];counter = 1;
for i=1:size(hkl_m1,1)
  for j=1:size(hkl_m2,1)
    tmp = acos ( dot(hkl_m1(i,:), hkl_m2(j,:)) / (sqrt( (hkl_m1(i,:)*hkl_m1(i,:)')*(hkl_m2(j,:)*hkl_m2(j,:)') )) );
    tmp = tmp*180/pi;
    allowed_angles(counter) = tmp;
    counter = counter+1;
  end
end
allowed_angles=unique(allowed_angles)
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [th, et, om, normalX normalY normalZ]= sfCalcAngles(struct_id, pair_id, grainPos_sample);
%get difspot pos
if pair_id==1
[spotX,spotY,spotIm]=mym(sprintf('select CentroidX,CentroidY,MaxImage from ss_crackedA_difspot where difspotID=%d',struct_id));
else
[spotX,spotY,spotIm]=mym(sprintf('select CentroidX,CentroidY,MaxImage from ss_crackedB_difspot where difspotID=%d',struct_id));
spotIm=spotIm+parameters.acq.nproj;
end
%calc omega
om=180*(spotIm/parameters.acq.nproj);

%put grain pos in setup (lab) reference
grainPos_setup(1)= cosd(om)*grainPos_sample(1)+sind(om)*grainPos_sample(2) ;
grainPos_setup(2)= -sind(om)*grainPos_sample(1)+cosd(om)*grainPos_sample(2) ;
grainPos_setup(3)= grainPos_sample(3) ;

%spot position in setup (lab) reference
spotPos_setup=[(parameters.acq.dist/parameters.acq.pixelsize), spotX-parameters.acq.rotx, parameters.acq.bb(2)-spotY];

%calc theta, eta
deltaX = spotPos_setup(2)-grainPos_setup(2);
deltaY = spotPos_setup(3)-grainPos_setup(3);%compared to gtMatchDifspots_v2b, sign of y has already been flipped
grain_to_det = spotPos_setup(1)-grainPos_setup(1);

th=acosd(grain_to_det / norm([grain_to_det deltaX deltaY]))/2;
et=(180/pi)*atan2(deltaX, deltaY);
if et<0
  et=360+et;
end

%calc plane normal (scattering vector)
diff_vec_setup = [grain_to_det deltaX deltaY]/norm([grain_to_det deltaX deltaY]);
pl_vec_setup = (diff_vec_setup-[1 0 0])/norm(diff_vec_setup-[1 0 0]) ;
%transform to sample coordinates
normalX = cosd(om)*pl_vec_setup(1)-sind(om)*pl_vec_setup(2) ;
normalY = sind(om)*pl_vec_setup(1)+cosd(om)*pl_vec_setup(2) ;
normalZ = pl_vec_setup(3) ;

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


end
