%
% Gives the spatial distance between a point and a line in 3D space.
% 
% FUNCTION: pointtolinedist(q,l)
%
% INPUT:    coordinates of the point = q[ q_X q_Y q_Z ] 
%           coordinates of lines = l(i,6) [ line_X line_Y line_Z line_dir_X line_dir_Y line_dir_Z ]
%
% OUTPUT:   distance(i,1)
%


function distance = pointtolinedist(q,l)

%distance= norm(cross((q-l(1:3)),l(4:6))/norm(l(4:6)));

for i=1:size(l,1)
   distance(i,1) = norm(cross((q-l(i,1:3)),l(i,4:6),2)/norm(l(i,4:6)));
end

