% 
% FUNCTION pointtolinedistsqrsum(q,l)
%
% Given a point 'q' and any number of lines 'l' in 3D space, gives the sum of square of the 'q' to 'l' distances.
%
% INPUT:    q [q_X q_Y q_Z]
%           l(i,6) [ l_X l_Y l_Z l_dir_X l_dir_Y l_dir_Z ]
%
% OUTPUT:   distance squared sum
%

function sqrsum = pointtolinedistsqrsum(q,l)

sqrsum=0 ;

for i=1:size(l,1) 
    
    a=cross((q-l(i,1:3)),l(i,4:6))/norm(l(i,4:6));
    sqrsum = sqrsum + dot(a,a);
    
end    
    
