function hf = gtMakeInversePoleFigure(varargin)
% GTMAKEINVERSEPOLEFIGURE  
%     hf = gtMakeInversePoleFigure(varargin)
%     ---------------------------
%

app.poles   = [];
app.LD      = [0 0 1];
app.range   = 'hex';
app.weights = [];
app.N       = 100;
app.searchR = 0.1;

app = parse_pv_pairs(app, varargin);

app.weights = ones(size(app.poles,1),1);
% before building figure, calculate phimax and psimax (allowing for search radius)
[~, ~, phimax, psimax] = gtFindPolesInRange(app.poles, [], app.range, []);
% analyse the pole data
[x,y,z] = gtCalculateDensityPhiPsi(app.poles, app.weights, [0 phimax], [0 psimax], app.searchR, app.N);

hf = gtIPFCmapHexagonalKey([],0,0);
figure(hf)
hold on
surfc(x,y,z)
shading('interp')
colormap(jet(app.N))
colorbar;
text(0,0.4,num2str(app.LD),'Color',[0 0 0],'fontsize',15,'fontweight','bold')

end
