function hp = gtPlotGrainUnitCell(gc, rvec, strainT, vertices, faces, hl, ga, cmap, linecolor, strainscale, alpha)

g_grain = Rod2g(rvec);

grain_vertices = ga*vertices*g_grain';
grain_vertices_st = repmat(gc,size(vertices,1),1) + (eye(3)*grain_vertices')';

if ~any(isnan(strainT(:))) && strainscale ~= 0
	  grain_vertices_st = grain_vertices_st + (strainT*strainscale*grain_vertices')';
end


facecolor = repmat(cmap,size(faces,1),1);


if hl
    hp = patch('vertices', grain_vertices_st, 'faces', faces, ...
               'FaceVertexCData',facecolor,'FaceColor','flat','EdgeColor',linecolor,...
               'LineWidth',2,'FaceAlpha',alpha);
else
    hp = patch('vertices', grain_vertices_st, 'faces', faces, ...
               'FaceVertexCData',facecolor,'FaceColor','flat','EdgeColor',linecolor,...
               'LineWidth',1,'FaceAlpha',alpha);
end
% 
% if hl
%     hp = drawMesh(grain_vertices_st, faces, ...
%                   'FaceVertexCData',facecolor,'FaceColor','flat','EdgeColor',linecolor,...
%                   'LineWidth',2,'FaceAlpha',alpha);
% else
%     hp = drawMesh(grain_vertices_st, faces, ...
%                   'FaceVertexCData',facecolor,'FaceColor','flat','EdgeColor',linecolor,...
%                   'LineWidth',1,'FaceAlpha',alpha);
% end


end  % of gtPlotGrainUnitCell
