function gtDBCreateDifspotTable(expname, overwriteflag)
% GTDBCREATEDIFSPOTTABLE  Creates the difspot table
%     gtDBCreateDifspotTable(expname, overwriteflag)
%     ---------------------------------------------
%
%


if ~exist('expname','var')
    expname=[];
end

if ~exist('overwriteflag','var')
    overwriteflag=false;
end

% if no name supplied, get it from parameters file
if isempty(expname)
    load('parameters.mat');
    expname=parameters.acq.name;
end

fprintf('Working on %s\n',expname);

gtDBConnect

tablename_difspot=sprintf('%sdifspot',expname);


if ~overwriteflag
    %check if any tables exist already
    check1=mym(sprintf('show tables like "%s"',tablename_difspot));
    if ~isempty(check1)
        error('At least one of the tables exists already! Run again using the overwriteflag=true');
    end
end


% difspot
mym(sprintf('drop table if exists %s',tablename_difspot));
mysqlcmd=sprintf('create table %s (difspotID int not null auto_increment, StartImage int, EndImage int, MaxImage int, ExtStartImage int, ExtEndImage int, Area double, CentroidX double, CentroidY double, CentroidImage double, BoundingBoxXorigin int, BoundingBoxYorigin int, BoundingBoxXsize int, BoundingBoxYsize int, Integral double, Bad int, primary key (difspotID))',tablename_difspot);
mym(mysqlcmd)

end

