function [info, columns] = gtDBTableInfo(tablename, verbose)
% Returns information about a database table and its columns.

if ~exist('verbose','var') || verbose
    mym(sprintf('describe %s',tablename))
end


[info.Name, info.Engine, info.Version, info.Row_format, info.Rows, ...
    info.Avg_row_length, info.Data_length, info.Max_data_length, ...
    info.Index_length, info.Data_free, info.Auto_increment, ...
    info.Create_time, info.Update_time, info.Check_time, info.Collation,...
    info.Checksum, info.Create_options, info.Comment] ...
    = mym(sprintf('show table status where Name = ''%s''',tablename));


[columns.Field, columns.Type, columns.Null, columns.Key, ...
    columns.Default, columns.Extra] ...
    = mym(sprintf('show columns from %s',tablename));


end


